W	equ	0		;W = 0
F	equ	1		;F = 1
;-------------------------------------------------------------------------------
;	Definice pinu
;-------------------------------------------------------------------------------
;	Sbernice
;-------------------------------
#define	BUS	PORTA,1		;sbernice
#define	BUS_T	TRISA,1		;tris sbernice
;-------------------------------
;	Tlacitka
;-------------------------------
#define	TL1	PORTB,2		;tlacitko 1 (ESC)
#define	TL2	PORTB,3		;tlacitko 2 (-)
#define	TL3	PORTB,4		;tlacitko 3 (+)
#define	TL4	PORTB,5		;tlacitko 4 (OK)
;-------------------------------
;	Piezo
;-------------------------------
#define	PIEZOT	LATC,6		;piezo tichy
#define	PIEZOH	LATC,7		;piezo hlasity
;-------------------------------
;	Displej
;-------------------------------
#define	RS	LATC,0		;konfiguracni piny
#define	RW	LATC,1
#define	E	LATC,2
;       ------------------------
#define	DB4	LATA,4		;datove piny
#define	DB5	LATA,5
#define	DB6	LATA,3
#define	DB7	LATA,2
;       ------------------------
#define	DB4_T	TRISA,4		;ekvivalenty datovych pinu v registru TRIS
#define	DB5_T	TRISA,5
#define	DB6_T	TRISA,3
#define	DB7_T	TRISA,2
;       ------------------------
#define	BFL	PORTA,2		;busy-flag
;-------------------------------
;	Teplotni cidlo
;-------------------------------
#define	TEP	PORTA,0		;DS18B20
#define	TEP_T	TRISA,0		;tris DS18B20
;-------------------------------------------------------------------------------
;	Definice registru
;-------------------------------------------------------------------------------
;
;	Systemovy registr a definice jeho bitu
;
;	| TMP |  | DISDC | DISSTA | DISDYN | SLEEPD | BEEPD | PRVNI |
;
;-------------------------------
SYS	equ	0x00
;
#define	PRVNI	SYS,0		;1 = prvni pruchod (nepipaji limity a dalsi dusledky)
#define	BEEPD	SYS,1		;1 = pozadavek pipnuti
#define	SLEEPD	SYS,2		;1 = displej vypnut
#define	DISDYN	SYS,3		;1 = dynamicke zobrazeni spodniho radku displeje
#define	DISSTA	SYS,4		;1 = staticke zobrazeni spodniho radku displeje
#define	DISDC	SYS,5		;1 = datum a cas na spodnim radku displeje
#define	TMP	SYS,7		;pomocny bit
;-------------------------------
TMP1	equ	0x01		;pomocny registr
TMP2	equ	0x02		;pomocny registr
TMP3	equ	0x03		;pomocny registr
TMP4	equ	0x04		;pomocny registr
TMP5	equ	0x05		;pomocny registr
;       ------------------------
CEK1	equ	0x06		;casova smycka
CEK2	equ	0x07		;casova smycka
CEK3	equ	0x08		;casova smycka
;       ------------------------
DAT	equ	0x09		;datovy registr
;       ------------------------
BCD	equ	0x0A		;cislo v BCD kodu
BCDD	equ	0x0B		;desitky v BCD kodu
BCDJ	equ	0x0C		;jednotky v BCD kodu
;       ------------------------
SPO	equ	0x0D		;sporic displeje
;-------------------------------
;
;	Registr chybovych stavu
;
;	|  |  |  | ERR05 | ERR04 | ERR03 | ERR02 | ERR01 |
;
;-------------------------------
ERR	equ	0x0E
;
#define	ERR01	ERR,0		;periferie kotel neodpovida
#define	ERR02	ERR,1		;periferie bojler neodpovida
#define	ERR03	ERR,2		;periferie alarm neodpovida
#define	ERR04	ERR,3		;periferie zaplava neodpovida
;-------------------------------
;
;	Registr stavu teplotnich cidel
;
;	| T4S2 | T4S1 | T3S2 | T3S1 | T2S2 | T2S1 | AS2 | AS1 |
;
;-------------------------------
TXS	equ	0x0F
;
#define	AS1	TXS,0		;Akumulator pod 12,2V
#define	AS2	TXS,1		;Akumulator nad 14,3V
;
#define	T2S1	TXS,2		;T2 pod limit 1
#define	T2S2	TXS,3		;T2 nad limit 2
;
#define	T3S1	TXS,4		;T3 pod limit 1
#define	T3S2	TXS,5		;T3 nad limit 2
;
#define	T4S1	TXS,6		;T4 pod limit 1
#define	T4S2	TXS,7		;T4 nad limit 2
;-------------------------------
;	Teplota T1 - bez limitu
;-------------------------------
T1DE	equ	0x10		;T1 desitky
T1JE	equ	0x11		;T1 jednotky
T1DT	equ	0x12		;T1 desetiny
;-------------------------------
;	Teplota T2
;-------------------------------
T2DE	equ	0x13		;T2 desitky
T2JE	equ	0x14		;T2 jednotky
T2DT	equ	0x15		;T2 desetiny
;
T2L1	equ	0x16		;T2 spodni limit
T2L2	equ	0x17		;T2 vrchni limit
;-------------------------------
;	Teplota T3 - vyuziva limity T4
;-------------------------------
T3DE	equ	0x18		;T3 desitky
T3JE	equ	0x19		;T3 jednotky
T3DT	equ	0x1A		;T3 desetiny
;-------------------------------
;	Teplota T4
;-------------------------------
T4DE	equ	0x1B		;T4 desitky
T4JE	equ	0x1C		;T4 jednotky
T4DT	equ	0x1D		;T4 desetiny
;
T4L1	equ	0x1E		;T4 spodni limit
T4L2	equ	0x1F		;T4 vrchni limit
;-------------------------------
;	Jimka
;-------------------------------
JIM	equ	0x20		;stav jimky
;-------------------------------
;	Akumulator
;-------------------------------
ADE	equ	0x21		;akumulator desitky
AJE	equ	0x22		;akumulator jednotky
ADT	equ	0x23		;akumulator desetiny
;-------------------------------
;	Alarm
;-------------------------------
ALARM	equ	0x24		;stav alarmu
;
PGSTAV	equ	0x25		;vystupy alarmu

PGSTAVP	equ	0x26		;vystupy alarmu - mezipamet
;
#define	PGX	PGSTAV,0	;1 = zakodovany alarm
#define	PGY	PGSTAV,1	;1 = vypadek napajeni ustredny
;
PGSTAV2	equ	0x27		;zmenove priznaky vystupu alarmu
;
;	| | | | | PG4 | PG3 | PG2 | PG1 |
;
#define	PG1	PGSTAV2,0	;1 = prave probehlo zakodovani alarmu
#define	PG2	PGSTAV2,1	;1 = prave probehlo odkodovani alarmu
#define	PG3	PGSTAV2,2	;1 = prave doslo k vypadku site
#define	PG4	PGSTAV2,3	;1 = prave doslo k obnoveni napajeni
;-------------------------------
;	Zaplava
;-------------------------------
ZAPLAVA	equ	0x28		;stav zaplavovych cidel
;
ZAPLAVP	equ	0x29		;stav zaplavovych cidel prijaty, ale nepotvrzeny
;
#define	Z1A	ZAPLAVA,0	;1 = vybavene cidlo Z1a
#define	Z1B	ZAPLAVA,1	;1 = vybavene cidlo Z1b
#define	Z2A	ZAPLAVA,2	;1 = vybavene cidlo Z2a
#define	Z2B	ZAPLAVA,3	;1 = vybavene cidlo Z2b
#define	Z3A	ZAPLAVA,4	;1 = vybavene cidlo Z3a
#define	Z3B	ZAPLAVA,5	;1 = vybavene cidlo Z3b
#define	Z4A	ZAPLAVA,6	;1 = vybavene cidlo Z4a
#define	Z4B	ZAPLAVA,7	;1 = vybavene cidlo Z4b
;
ZAPLAV2	equ	0x2A		;stav zaplavovych cidel
;
ZAPLA2P	equ	0x2B		;stav zaplavovych cidel prijaty, ale nepotvrzeny
;
#define	Z1	ZAPLAV2,0	;1 = vybavene cidlo Z1
#define	Z2	ZAPLAV2,1	;1 = vybavene cidlo Z2
#define	Z3	ZAPLAV2,2	;1 = vybavene cidlo Z3
#define	Z4	ZAPLAV2,3	;1 = vybavene cidlo Z4
;
#define	ZX	ZAPLAV2,7	;1 = vybavene nektere cidlo
;-------------------------------
;	Vnitrni teplotni cidlo
;-------------------------------
DES	equ	0x30
TDE	equ	0x31
TJE	equ	0x32
TDT	equ	0x33
;
LSB	equ	0x34
MSB	equ	0x35
;-------------------------------
;	Obvod realneho casu
;-------------------------------
SEKUNDY	equ	0x36
MINUTY	equ	0x37
HODINY	equ	0x38
DENVTY	equ	0x39
DEN	equ	0x3A
MESIC	equ	0x3B
ROK	equ	0x3C
;-------------------------------
;	Dalsi registry
;-------------------------------
KURZOR	equ	0x3D		;aktualni pozice kurzoru displeje
BCDMAX	equ	0x3E		;maximalni hodnota inkrementace BCD
RADEK2	equ	0x3F		;ukazatel druheho radku pohotovostniho displeje

PM_CE1	equ	0x40		;registry pro ukonceni menu pri necinnosti
PM_CE2	equ	0x41
PM_CE3	equ	0x42
;-------------------------------------------------------------------------------
;
;	Systemovy registr 2 a definice jeho bitu
;
;	|  |  |  |  |  |  |  | PM_TMP |
;
;-------------------------------
SYS2	equ	0x43
;
#define	PM_TMP	SYS2,0		;1 = pozadavek ukonceni menu