;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;
;	Knihovna pro obsluhu pameti EEPROM
;
;	Procesor:	18F25K50	
;	Rychlost:	-
;
;	Autor:		Milan rajer, www.milansrajer.cz
;	Datum:		08/2016
;
;-------------------------------------------------------------------------------
;
;	Volani maker (nutny include piclib_macro)
;	------------------------
;	eeread	0x00,0x01	- nacte byte z eeprom adresy 0001 do W
;	eewrite	REG,0x00,0x01	- ulozi obsah REG na adresu 0001 eeprom
;
;-------------------------------------------------------------------------------
;
;	Pozadavky - registry
;	------------------------
;	CEK1 - registr cekacich smycek
;	CEK2 - registr cekacich smycek
;
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;	ovladani EEPROM prostrednictim maker
;-------------------------------
eeread	macro	pa2
;       ------------------------
;	movlw	pa1		;adresa H eeprom do W
;	movwf	EEADRH		;W do EEADRH
	movlw	pa2		;adresa L eeprom do W
	movwf	EEADR		;W do EEADR
;       ------------------------
	call	ee_rea		;volani podprogramu pro cteni
;       ------------------------
	endm
;-------------------------------------------------------------------------------
eewrite	macro	pa1, pa3
;       ------------------------
	movf	pa1,0		;data k ulozeni do W
	movwf	EEDATA		;W do EEDATA
;	movlw	pa2		;adresa H eeprom do W
;	movwf	EEADRH		;W do EEADRH
	movlw	pa3		;adresa L eeprom do W
	movwf	EEADR		;W do EEADR
;       ------------------------
	call	ee_wri		;volani podprogramu pro zapis
;       ------------------------
	endm
;-------------------------------------------------------------------------------
;	Cteni z pameti EEPROM
;-------------------------------
ee_rea	movwf	EEADR		;W do EEADR
;       ------------------------
	bcf	EECON1,EEPGD	;nastaveni datove pameti
	bcf	EECON1,CFGS	;pristup k EEPROM
	bsf	EECON1,RD	;EEPROM read
	movf	EEDATA,0	;W = EEDATA	!!! data v registru W !!!
;       ------------------------
	return
;-------------------------------------------------------------------------------
;	Zapis do pameti EEPROM
;-------------------------------
ee_wri	bcf	EECON1,EEPGD	;nastaveni datove pameti
	bcf	EECON1,CFGS	;pristup k EEPROM
	bsf	EECON1,WREN	;povolit zapis do EEPROM
;       ------------------------
	bcf	INTCON,GIE	;zakazano preruseni
;       ------------------------			
	movlw	055h		;aktivace zapisu
	movwf	EECON2
	movlw	0AAh
	movwf	EECON2
	bsf	EECON1,WR	;spustit zapis
_eew1	btfsc	EECON1,WR	;pockat na konec zapisu
	goto	_eew1
;       ------------------------
;	bsf	INTCON,GIE	;povoleni preruseni, pokud je treba
;       ------------------------
	movlw	.40		;(40) a jeste 5ms pockame
        movwf	CEK2
_eew3	movlw	.207		;(207)
        movwf	CEK1
;       ------------------------
_eew2	decfsz	CEK1,1
        goto	_eew2
        decfsz	CEK2,1
        goto	_eew3
;       ------------------------
	bcf	EECON1,WREN	;zakazat zapis do EEPROM
;       ------------------------
	return
;-------------------------------------------------------------------------------
