;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
;
;	Knihovna I2c
;
;	Procesor:	18F25K50
;	Rychlost:	20MHz
;
;	Milan rajer		
;	08/2016
;
;-------------------------------------------------------------------------------
;
;	Volani
;	------------------------
;	call	i2c_start	- start bit
;	call	i2c_restart	- restart bit
;	call	i2c_stop	- stop bit
;	call	i2c_posli_byte	- vysle byte
;	call	i2c_cti_byte	- precte byte	
;	call	i2c_ack		- potvrzeni
;	call	i2c_nack	- nepotvrzeni	
;
;-------------------------------------------------------------------------------
;
;	Bez pozadavku
;
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
i2c_start
	bcf	PIR1,SSPIF	;smaz priznak preruseni
;       ------------------------
	bsf	SSP1CON2,SEN	;vysli start bit
	btfsc	SSP1CON2,SEN	;bylo vysilani dokonceno?
	goto	$-2		;ne, opakuj dotaz
	return
;-------------------------------------------------------------------------------
i2c_restart
	bcf	PIR1,SSPIF	;smaz priznak preruseni
;       ------------------------
	bsf	SSP1CON2,RSEN	;vysli start bit
	btfsc	SSP1CON2,RSEN	;bylo vysilani dokonceno?
	goto	$-2		;ne, opakuj dotaz
	return
;-------------------------------------------------------------------------------
i2c_stop
	bcf	PIR1,SSPIF	;smaz priznak preruseni
;       ------------------------
	bsf	SSP1CON2,PEN	;vysli stop bit
	btfsc	SSP1CON2,PEN
	goto	$-2
	return
;-------------------------------------------------------------------------------
i2c_posli_byte
	bcf	PIR1,SSPIF	;smaz priznak preruseni
;       ------------------------
	movwf	SSP1BUF		;vloz data do SSP1BUF
;       ------------------------
	btfss	PIR1,SSPIF	;bylo SSP kompletne odeslano?
	goto	$-2		;ne, opakuj dotaz
;       ------------------------
	btfsc	SSP1CON2,ACKSTAT ;byl prijmut ACK od slave?
	goto	$-2
;       ------------------------
	return
;-------------------------------------------------------------------------------
i2c_cti_byte
	bcf	PIR1,SSPIF	;smaz priznak preruseni
;       ------------------------
	bsf	SSP1CON2,RCEN	;precti byte ze slave
;       ------------------------
	btfsc	SSP1CON2,RCEN	;pockej na dokonceni cteni
	goto	$-2
;       ------------------------
	return
;-------------------------------------------------------------------------------
i2c_ack
	bcf	PIR1,SSPIF	;smaz priznak preruseni
;       ------------------------
	bcf	SSP1CON2,ACKDT	;ACK
;       ------------------------
	bsf	SSP1CON2,ACKEN	;vysli ACKDT bit
;       ------------------------
	btfsc	SSP1CON2,ACKEN	;pockej na dokonceni ACK
	goto	$-2
;       ------------------------
	return
;-------------------------------------------------------------------------------
i2c_nack
	bcf	PIR1,SSPIF	;smaz priznak preruseni
;       ------------------------
	bsf	SSP1CON2,ACKDT	;NACK
;       ------------------------
	bsf	SSP1CON2,ACKEN	;vysli ACKDT bit
;       ------------------------
	btfsc	SSP1CON2,ACKEN	;pockej na dokonceni NACK
	goto	$-2
;       ------------------------
	return