;================================================================================
;
;	Podprogram pro komunikaci po sbernici
;
;================================================================================
;--------------------------------------------------------------------------------
;	Odeslani dat z ridici jednotky
;--------------------------------------------------------------------------------
bus00	call	res_bus		;vysli reset impuls
;       ------------------------
	movlw	b'00000000'	;adresuj periferii (zde adresa 00)
	call	w_bus
;       ------------------------
	movf	SEKUNDY,W	;vysli RTC
	call	w_bus
	movf	MINUTY,W
	call	w_bus
	movf	HODINY,W
	call	w_bus
	movf	DENVTY,W
	call	w_bus
	movf	DEN,W
	call	w_bus
	movf	MESIC,W
	call	w_bus
	movf	ROK,W
	call	w_bus
;       ------------------------
	movf	TDE,W		;vysli teplotu v mistnosti
	call	w_bus
	movf	TJE,W
	call	w_bus
	movf	TDT,W
	call	w_bus
;       ------------------------
	movf	T2L1,W		;vysli T2 spodni limit (BCD)
	call	w_bus
	movf	T2L2,W		;vysli T2 horni limit (BCD)
	call	w_bus
	movf	T4L1,W		;vysli T4 spodni limit (BCD)
	call	w_bus
	movf	T4L2,W		;vysli T4 horni limit (BCD)
	call	w_bus
;       ------------------------
	movf	SYS,W		;vysli systemovy registr
	call	w_bus
	movf	ERR,W		;vysli chybovy registr
	call	w_bus
;       ------------------------
	movlw	b'01010101'	;kontrolni byte
	call	w_bus
;--------------------------------------------------------------------------------
;	PERIFERIE 00000001 - kotel, zdroj
;--------------------------------------------------------------------------------
bus01	call	res_bus		;vysli reset impuls
;       ------------------------
	movlw	b'00000001'	;adresuj periferii
	call	w_bus
;-------------------------------
	call	bus_dat		;T1 desitky
	movf	DAT,W
	movwf	T1DE
	call	bus_dat		;T1 jednotky
	movf	DAT,W
	movwf	T1JE
	call	bus_dat		;T1 desetiny
	movf	DAT,W
	movwf	T1DT
;       ------------------------
	call	bus_dat		;T2 desitky
	movf	DAT,W
	movwf	T2DE
	call	bus_dat		;T2 jednotky
	movf	DAT,W
	movwf	T2JE
	call	bus_dat		;T2 desetiny
	movf	DAT,W
	movwf	T2DT
;       ------------------------
	call	bus_dat		;AKU desitky
	movf	DAT,W
	movwf	ADE
	call	bus_dat		;AKU jednotky
	movf	DAT,W
	movwf	AJE
	call	bus_dat		;AKE desetiny
	movf	DAT,W
	movwf	ADT
;       ------------------------
	call	bus_dat		;kontrolni byte
	movf	DAT,W
	movwf	TMP3
;-------------------------------
;	Kontrola spravneho prijmu
;-------------------------------
	movlw	b'01010101'
	subwf	TMP3,W
	btfss	STATUS,Z
	goto	bus01e
;-------------------------------
;	Po spravnem prijmu
;-------------------------------
	bcf	ERR01		;vymaz chybovy priznak
	goto	bus02
;-------------------------------
;	Po spatnem prijmu
;-------------------------------
bus01e	bsf	ERR01		;nastav chybovy priznak
;	------------------------
	clrf	T1DE
	clrf	T1JE
	clrf	T1DT
;	------------------------
	clrf	T2DE
	clrf	T2JE
	clrf	T2DT
;	------------------------
	clrf	ADE
	clrf	AJE
	clrf	ADT
;--------------------------------------------------------------------------------
;	PERIFERIE 00000010 - bojler, jimka
;--------------------------------------------------------------------------------
bus02	call	res_bus		;vysli reset impuls
;       ------------------------
	movlw	b'00000010'	;adresuj periferii
	call	w_bus
;-------------------------------
	call	bus_dat		;T3 desitky
	movf	DAT,W
	movwf	T3DE
	call	bus_dat		;T3 jednotky
	movf	DAT,W
	movwf	T3JE
	call	bus_dat		;T3 desetiny
	movf	DAT,W
	movwf	T3DT
;       ------------------------
	call	bus_dat		;T4 desitky
	movf	DAT,W
	movwf	T4DE
	call	bus_dat		;T4 jednotky
	movf	DAT,W
	movwf	T4JE
	call	bus_dat		;T4 desetiny
	movf	DAT,W
	movwf	T4DT
;       ------------------------
	call	bus_dat		;JIM
	movf	DAT,W
	movwf	JIM
;       ------------------------
	call	bus_dat		;kontrolni byte
	movf	DAT,W
	movwf	TMP3
;-------------------------------
;	Kontrola spravneho prijmu
;-------------------------------
	movlw	b'01010101'
	subwf	TMP3,W
	btfss	STATUS,Z
	goto	bus02e
;-------------------------------
;	Po spravnem prijmu
;-------------------------------
	bcf	ERR02		;vymaz chybovy priznak
	goto	bus03
;-------------------------------
;	Po spatnem prijmu
;-------------------------------
bus02e	bsf	ERR02		;nastav chybovy priznak
;	------------------------
	clrf	JIM
	bsf	JIM,7
;--------------------------------------------------------------------------------
;	PERIFERIE 00000011 - alarm
;--------------------------------------------------------------------------------
bus03	call	res_bus		;vysli reset impuls
;       ------------------------
	movlw	b'00000011'	;adresuj periferii
	call	w_bus
;       ------------------------
	movf	ALARM,W		;vysli alarmy
	call	w_bus
;-------------------------------
	call	bus_dat		;precti stav vystupu ustredy alarmu
	movf	DAT,W
	movwf	PGSTAVP
;       ------------------------
	call	bus_dat		;kontrolni byte
	movf	DAT,W
	movwf	TMP3
;-------------------------------
;	Kontrola spravneho prijmu
;-------------------------------
	movlw	b'01010101'
	subwf	TMP3,W
	btfss	STATUS,Z
	goto	bus03e
;-------------------------------
;	Po spravnem prijmu
;-------------------------------
	bcf	ERR03		;vymaz chybovy priznak
;       ------------------------
	clrf	PGSTAV2		;vymaz vsechny zmenove priznaky
;       ------------------------
pg01	btfsc	PGSTAVP,0	;doslo k zakodovani alarmu?
	goto	pg02
	btfss	PGSTAV,0
	goto	pg02
;       ------------------------
	bsf	PG1		;nastav priznak zakodovani alarmu			
	goto	pg03
;       ------------------------
pg02	btfss	PGSTAVP,0	;doslo k odkodovani alarmu?
	goto	pg03
	btfsc	PGSTAV,0
	goto	pg03
;       ------------------------
	bsf	PG2		;nastav priznak odkodovani alarmu			
;       ------------------------
pg03	btfsc	PGSTAVP,1	;doslo k vypadku site?
	goto	pg04
	btfss	PGSTAV,1
	goto	pg04
;       ------------------------			
	bsf	PG3		;nastav priznak vypadku site			
	goto	pgend
;       ------------------------
pg04	btfss	PGSTAVP,1	;doslo k obnoveni napajeni?
	goto	pgend
	btfsc	PGSTAV,1
	goto	pgend
;       ------------------------				
	bsf	PG4		;nastav priznak obnoveni napajeni
;       ------------------------
pgend	movf	PGSTAVP,W	;presun byte po spravnem prijmu
	movwf	PGSTAV
;       ------------------------
	goto	bus04
;-------------------------------
;	Po spatnem prijmu
;-------------------------------
bus03e	bsf	ERR03		;nastav chybovy priznak
;       ------------------------
;--------------------------------------------------------------------------------
;	PERIFERIE 00000100 - zaplava
;--------------------------------------------------------------------------------
bus04	call	res_bus		;vysli reset impuls
;       ------------------------
	movlw	b'00000100'	;adresuj periferii
	call	w_bus
;       ------------------------
	call	bus_dat		;precti byte ZAPLAVA
	movf	DAT,W
	movwf	ZAPLAVP
;       ------------------------
	call	bus_dat		;precti byte ZAPLAV2
	movf	DAT,W
	movwf	ZAPLA2P
;       ------------------------
	call	bus_dat		;precti kontrolni byte
	movf	DAT,W
	movwf	TMP3
;-------------------------------
;	Kontrola spravneho prijmu
;-------------------------------
	movlw	b'01010101'
	subwf	TMP3,W
	btfss	STATUS,Z
	goto	bus04e
;-------------------------------
;	Po spravnem prijmu
;-------------------------------
	bcf	ERR04		;vymaz chybovy priznak
;
	movf	ZAPLAVP,W	;presun byte po spravnem prijmu
	movwf	ZAPLAVA
	movf	ZAPLA2P,W	;presun byte po spravnem prijmu
	movwf	ZAPLAV2
;       ------------------------
	return
;-------------------------------
;	Po spatnem prijmu
;-------------------------------
bus04e	bsf	ERR04		;nastav chybovy priznak
;       ------------------------
	return